<?php
/**
 * Slot.class.php
 *
 * @author  Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @author  Ivn Marcos <ivan.marcos@gmx.net>
 * @author  Nico Mueller <nico.mueller@uni-oldenburg.de>
 * @package IBIT_SprechstundenPlugin
 * @copyright IBIT 2006-2008
 * @version 1.7.5
 */

// Imports
require_once "TermsDescription.class.php";
require_once "Term.class.php";

/**
 * Enter description here...
 *
 */
class Slot
{

	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $id = -1;

	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $term_id = -1;

	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $position = -1;

	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $occupied = -1;

	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	private $db;

	/**
	 * Konstruktor
	 *
	 * @param string $slotid
	 */
	public function __construct($slotid = -1)
	{
		$this->db = new DB_Seminar;
		if ($slotid > 0)
		{
			$this->db->queryf("SELECT * FROM `SprechstundenZeitSlot` WHERE `id`=%s", $slotid);
			if ($this->db->next_record())
			{
				$this->id = $slotid;
				$this->term_id = $this->db->f('termin_id');
				$this->position = $this->db->f('position');
				$this->occupied = $this->db->f('belegt');
			}
		}
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $term_id
	 * @param unknown_type $position
	 * @param unknown_type $occupied
	 * @return boolean
	 */
	public function insert($term_id, $position, $occupied)
	{
		$this->db->queryf("INSERT INTO `SprechstundenZeitSlot` (`id`,`termin_id`,`position`,`belegt`) VALUES ('', '%s', '%s', '%s')", $term_id, $position, $occupied);
		$this->db->queryf("SELECT id FROM `SprechstundenZeitSlot` WHERE `termin_id` = '%s' AND `position` = '%s' AND `belegt` = '%s';", $term_id, $position, $occupied);
		if($this->db->next_record())
		{
			$this->id = $this->db->f('id');
			$this->term_id = $term_id;
			$this->position = $position;
			$this->occupied = $occupied;
			return true;
		}
		else
		{
			return false;
		}
	}

	/**
	 * Enter description here...
	 *
	 * @return timestamp
	 */
	public function slotStartStamp()
	{
		$term = new Term($this->term_id);
		$desc = new TermsDescription($term->desc_id);
		return ($term->start_stamp + ( (($desc->duration)*60) * ($this->position-1)));
	}

	/**
	 *  term start stamp + duration in seconds + position
	 *
	 * @return timestamp
	 */
	public function slotEndStamp()
	{
		$term = new Term($this->term_id);
		$desc = new TermsDescription($term->desc_id);
		return ($term->start_stamp + ( (($desc->duration)*60) * ($this->position)));
	}

	/**
	 * Enter description here...
	 *
	 * @param string $status
	 * @return boolean
	 */
	public function setOccupationStatus($status)
	{
		$this->occupied = $status;
		$this->db->queryf("UPDATE `SprechstundenZeitSlot` SET `belegt`='%s' WHERE id='%s'", $this->occupied, $this->id);
		return true;
	}

	/**
	 * is there a student in it?
	 *
	 * @return boolean
	 */
	public function hasStudentIn()
	{
		$sql = "SELECT STUDENT.user_id FROM `SprechstundenAnmeldung` as STUDENT"
			. " INNER JOIN `SprechstundenZeitSlot` as SLOT ON STUDENT.zeitslot_id=SLOT.id WHERE SLOT.id='%s';";
		$this->db->queryf($sql, $this->id);
		if ($this->db->num_rows() > 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

    /**
     * Lscht einen Sprechstundentermin Slot
     *
     * @return int the number of affected rows
     */
    public function delete()
    {
        return DBManager::get()->exec("DELETE FROM SprechstundenZeitSlot WHERE `id`= {$this->id}");
    }
}