<?php
/**
 * StudentReservation.class.php
 *
 * @author  Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @author  Ivn Marcos <ivan.marcos@gmx.net>
 * @author  Nico Mueller <nico.mueller@uni-oldenburg.de>
 * @package IBIT_SprechstundenPlugin
 * @copyright IBIT 2006-2008
 * @version 1.7.5
 */

// require calendar
require_once($GLOBALS['STUDIP_BASE_PATH'].'/'.$GLOBALS['RELATIVE_PATH_CALENDAR'].'/lib/DbCalendarEvent.class.php');
require_once "TermsDescription.class.php";
require_once "Term.class.php";
require_once "Slot.class.php";

/**
 * Enter description here...
 *
 */
class StudentReservation
{
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $id = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $term_id = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $student_id = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $slot_id = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $remark = '';
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $event_id_teacher = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $event_id_student = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $db;

	/**
	 *
	 * constructor ...
	 *
	 */
	function __construct($id = -1)
	{
		$this->db = new DB_Seminar;
		if ($id > 0)
		{
			$this->db->queryf("SELECT * FROM `SprechstundenAnmeldung` WHERE (`id`='%s')", $id);
			if ($this->db->next_record())
			{
				// set
				$this->id = $id;
				$this->term_id = $this->db->f('termin_id');
				$this->slot_id = $this->db->f('zeitslot_id');
				$this->student_id = $this->db->f('user_id');
				$this->event_id_teacher = $this->db->f('event_id_dozent');
				$this->event_id_student = $this->db->f('event_id_student');
				$this->remark = $this->db->f('grund');
			}
		}
	}

	/**
	 * Speicert den Termin in den Kalender
	 *
	 * @param unknown_type $summary
	 * @param unknown_type $userid
	 * @param unknown_type $description
	 * @param unknown_type $location
	 * @param unknown_type $dtstart
	 * @param unknown_type $dtend
	 * @return $string CalendarTerminID
	 */
	public function insertCalendar($summary, $userid, $description, $location, $dtstart, $dtend)
	{
		// new
		$atermin =& new DbCalendarEvent();
		// set the values
		$atermin->user_id = $userid;
		$atermin->properties['DTSTART'] = $dtstart;
		$atermin->properties['DTEND'] = $dtend;
		$atermin->properties['SUMMARY'] = $summary;
		$atermin->properties['PRIORITY'] = 0;
		$atermin->properties['STUDIP_CATEGORY'] = 1;
		$atermin->properties['LOCATION'] = $location;
		$atermin->properties['DESCRIPTION'] = $description;
		$atermin->setDayEvent(FALSE);
		$atermin->setType('PRIVATE');
		$atermin->setRepeat(array('rtype' => 'SINGLE', 'expire' => null));
		// insert
		$atermin->save();
		// return the id
		return $atermin->getId();
	}

	/**
	 * insert into db, create a calendar entry, update slot
	 *
	 * @param unknown_type $term_id
	 * @param unknown_type $slot_id
	 * @param unknown_type $logged_in_id
	 * @param unknown_type $teacher_id
	 * @param unknown_type $student_id
	 * @param unknown_type $remark
	 * @return unknown
	 */
	public function save($term_id, $slot_id, $logged_in_id, $teacher_id, $student_id, $remark)
	{
		$this->term_id = $term_id;
		$this->slot_id = $slot_id;
		$this->student_id = $student_id;
		$this->remark = strlen(trim($remark)) ? $remark : _("Keinen Grund angegeben.");

		// ---- 1.- insert into the db , if the slot is still FREE !! ----
		$sql = "INSERT INTO `SprechstundenAnmeldung`"
				. " (`id`,`termin_id`,`zeitslot_id`,`user_id`,`event_id_dozent`,`event_id_student`,`grund`)"
				. " VALUES (NULL, '%s', '%s', '%s', 'TMP_ID', 'TMP_ID', '%s')";
		$this->db->queryf($sql, $this->term_id, $this->slot_id, trim($this->student_id), trim($this->remark));
		$this->db->queryf("SELECT id FROM `SprechstundenAnmeldung` WHERE `termin_id` = '%s' AND `zeitslot_id` = '%s';", $this->term_id, $this->slot_id);
		if($this->db->next_record())
		{
			$this->id = $this->db->f("id");
		}
		if ($this->id <= 0)
		{
			echo "keine ID erzeugt in SprechstundenAnmeldung";
			return false;
		}
		// update the calendar
		else
		{
			$term = new Term($this->term_id);
			$desc = new TermsDescription($term->desc_id);
			$slot = new Slot($this->slot_id);

			// ---- 2.- insert calendar ----

			$student_class = new UserManagement($this->student_id);
			$student_header = "Sprechstundentermin mit " . $student_class->user_data["auth_user_md5.Vorname"] . " "
										. $student_class->user_data["auth_user_md5.Nachname"];
			$teacher_class = new UserManagement($teacher_id);
			$teacher_header = "Sprechstundentermin bei ". $teacher_class->user_data["auth_user_md5.Vorname"] . " "
										. $teacher_class->user_data["auth_user_md5.Nachname"];

			//In die Kalender eintragen
			$this->event_id_teacher = $this->insertCalendar($student_header, $teacher_id, $this->remark, $desc->place, $slot->slotStartStamp(), $slot->slotEndStamp());
			$this->event_id_student = $this->insertCalendar($teacher_header, $this->student_id, $this->remark, $desc->place, $slot->slotStartStamp(), $slot->slotEndStamp());

			$this->db->queryf("UPDATE `calendar_events` SET range_id='%s',autor_id='%s' WHERE `event_id`='%s'", $teacher_id, $teacher_id, $this->event_id_teacher);
			$this->db->queryf("UPDATE `calendar_events` SET range_id='%s',autor_id='%s' WHERE `event_id`='%s'", $this->student_id, $this->student_id, $this->event_id_student);

			// ---- 3.- update the reservation in DB ----
			$this->db->queryf("UPDATE `SprechstundenAnmeldung` SET event_id_dozent='%s', event_id_student='%s' WHERE `id`='%s';", $this->event_id_teacher, $this->event_id_student, $this->id);

			// ---- 4.- update slot status ----
			$slot->setOccupationStatus(1); // 1 = booked

			// ---- 5.- send the message -> logged-in user to the other
			$logged_in_id == $teacher_id ? $receiver_id = $student_id : $receiver_id = $teacher_id;

			// receiver name
			$user_class = new UserManagement($receiver_id);
			$rec_uname = $user_class->user_data["auth_user_md5.username"];

			// the message
			$message = "\n" . "Am :\t\t" . date("d.m.Y",$term->start_stamp);
			$message .= "\n" . "Ort :\t\t" . $desc->place;
			$teacher_class = new UserManagement($desc->teacher_id);
			$message .= "\n" . "Bei :\t\t" . $teacher_class->user_data["auth_user_md5.Vorname"]
						. " " . $teacher_class->user_data["auth_user_md5.Nachname"]
						. " <" . $teacher_class->user_data["auth_user_md5.Email"] . ">";
			$message .= "\n" . "Zeit :\t" . date("H:i",$slot->slotStartStamp()) . "-" . date("H:i",$slot->slotEndStamp());
			$message .= "\n" . "Grund :\t" . $this->remark;

			// ---- 6.- send message ----
			$msging = new messaging;
			$time = $tmp_message_id = $set_deleted = $signature = $force_email = '';
			$msging->insert_message(addslashes($message), $rec_uname,$logged_in_id,$time,$tmp_message_id,$set_deleted,$signature,_("Sprechstundentermin zugesagt"),$force_email);
			return true;
		}
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $reason
	 * @param unknown_type $logged_in_id
	 * @param unknown_type $teacher_id
	 * @param unknown_type $student_id
	 * @param unknown_type $slot
	 * @return unknown
	 */
	function cancel($reason, $logged_in_id, $teacher_id, $student_id, $slot)
	{
		$term = new Term($this->term_id);
		$desc = new TermsDescription($term->desc_id);

		// --- step 1 - cancel (delete) the student's reservation ---
		$this->db->queryf("DELETE FROM `SprechstundenAnmeldung` WHERE (`id`='%s')", $this->id);

		// --- step 2 - delete the calendar's entries
		$this->db->queryf("DELETE FROM `calendar_events` WHERE (`event_id`='%s')", $this->event_id_teacher);
		$this->db->queryf("DELETE FROM `calendar_events` WHERE (`event_id`='%s')", $this->event_id_student);

		// --- step 3 - send the messages --- logged-in user to the other
		$logged_in_id == $teacher_id ? $receiver_id = $student_id : $receiver_id = $teacher_id;

		// receiver name
		$user_class = new UserManagement($receiver_id);
		$rec_uname = $user_class->user_data["auth_user_md5.username"];
		// the message
		$message = "\n" . "Am :\t\t" . date("d.m.Y",$term->start_stamp);
		$message .= "\n" . "Ort :\t\t" . $desc->place;
		$teacher_class = new UserManagement($desc->teacher_id);
		$message .= "\n" . "Bei :\t\t" . $teacher_class->user_data["auth_user_md5.Vorname"]
					. " " . $teacher_class->user_data["auth_user_md5.Nachname"]
					. " <" . $teacher_class->user_data["auth_user_md5.Email"] . ">";
		$message .= "\n" . "Zeit :\t" . date("H:i",$slot->slotStartStamp())
						. "-" . date("H:i",$slot->slotEndStamp());
		$message .= "\n" . "Grund :\t" . $reason;

		$msging = new messaging;
		$time = $tmp_message_id = $set_deleted = $signature = $force_email = '';
		$msging->insert_message(addslashes($message),$rec_uname,$logged_in_id,$time,$tmp_message_id,$set_deleted,$signature,_("Sprechstundentermin abgesagt!"),$force_email);

		// 4.- free the slot
		$slot->setOccupationStatus('0');
		return true;
	}
}

?>
