<?php
/**
 * TermsDescription.class.php
 *
 * @author  Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @author  Ivn Marcos <ivan.marcos@gmx.net>
 * @author  Nico Mueller <nico.mueller@uni-oldenburg.de>
 * @package IBIT_SprechstundenPlugin
 * @copyright IBIT 2006-2008
 * @version 1.7.5
 */

/**
 * Enter description here...
 *
 */
class TermsDescription
{
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $id = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $teacher_id = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $start_stamp = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $end_stamp = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $day_of_the_week = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $place = '';
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $interval = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $duration = -1;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $db;

	/**
	 *
	 * Konstruktor
	 *
	 */
	function __construct($id = -1)
	{
		$this->db = new DB_Seminar;
		if ($id > 0)
		{
			$this->db->queryf("SELECT * FROM `SprechstundenTerminDesc` WHERE (`id`= '%s')", $id);
			if ($this->db->next_record())
			{
				$this->id = $id;
				$this->teacher_id = $this->db->f('dozent_id');
				$this->start_stamp =$this->db->f('start_date');
				$this->end_stamp = $this->db->f('end_date');
				$this->day_of_the_week = $this->db->f('am');
				$this->place = $this->db->f('ort');
				$this->interval = $this->db->f('intervall');
				$this->duration = $this->db->f('dauer');
			}
		}
		return true;
	}

    /**
     * Speichert einen neuen Eintrag in die Datenbank
     *
     * @return $id oder false
     */
    public function insert($userid)
    {
        // set
        $this->teacher_id = $userid;
        $this->start_stamp =strtotime(Request::get('start') . ' ' . Request::get('start_hour'). ':'. Request::get('start_minute'));
        $this->end_stamp =strtotime(Request::get('ende') . ' ' . Request::get('ende_hour'). ':'. Request::get('ende_minute'));
        $this->day_of_the_week = Request::int('day_of_the_week');
        $this->place = Request::get('place');
        $this->interval =  Request::int('interval');
        $this->duration = Request::int('duration');

        //berprfung, ob es diesen block schon gibt
        $check = DBManager::get()->query("SELECT id FROM SprechstundenTerminDesc WHERE dozent_id='{$userid}' AND start_date='{$this->start_stamp}' AND end_date='{$this->end_stamp}' AND intervall='{$this->interval}' AND dauer='{$this->duration}' ")->fetch(PDO::FETCH_COLUMN);
        if(empty($check)) {
            //wenn nicht, dann anlegen und id zurckgeben...
            $db = DBManager::get()->prepare("INSERT INTO SprechstundenTerminDesc (`dozent_id`,`start_date`,`end_date`,`am`,`ort`,`intervall`,`dauer`) VALUES (?,?,?,?,?,?,?)");
            $db->execute(array($this->teacher_id, $this->start_stamp, $this->end_stamp, $this->day_of_the_week, $this->place, $this->interval, $this->duration));

            //wurde gespeichert...
            if($db->rowCount() > 0){
                //id zuweisen
                $this->id = DBManager::get()->query("SELECT MAX(id) FROM SprechstundenTerminDesc")->fetchColumn();

                //und jetzt termine anlegen
                $anzahl_termine = $this->createTermsAndSlots();

                // wenn termine angelegt wurden -> ende
                if($anzahl_termine != 0) {
                    return array('success' => 'Es wurden erfolgreich '.$anzahl_termine.' Sprechstundentermine angelegt.');
                }
                //ansonsten den block wieder lschen
                else {                	
                    $db = DBManager::get()->prepare("DELETE FROM `SprechstundenTerminDesc` WHERE id = ?");
                    $db->execute(array($this->id));
                    return array('error' => array('In diesem Sprechstundenterminblock befinden sich keine Termine.', 'Bitte berprfen Sie Ihre Angaben (insbesondere den ausgewhlten Wochentag)'));
                }
            }
        } else {        	
        	echo createQuestion('Einen Sprechstundenblock zu diesem Datum und mit dieser Startzeit ist bereits vorhanden. Sie mssen diesen Block erst lschen, bevor Sie zur selben Zeit einen neuen Block anlegen knnen! Mchten Sie das?', array("action" => "deletereally","start_stamp" => $this->start_stamp, "end_stamp" => $this->end_stamp));
        	return array('error' => array('Dieser Sprechstundenterminblock ist bereits vorhanden.', 'Bitte berprfen Sie Ihre Angaben.'));
        }
    }

	/**
	 * Erzeugt zu einem Eintrag die passenden Termine und TimeSlots
	 *
	 * @return unknown
	 */
	public function createTermsAndSlots()
	{
		// check the id
		if ($this->id <= 0)
		{
			return false;
		}
		else
		{
			// start first term
			$year_start_date = date("Y",$this->start_stamp);
			$month_start_date = date("n",$this->start_stamp);
			$day_start_date = date("d",$this->start_stamp);
			$hour_start_date = date("G",$this->start_stamp);
			$minute_start_date = date("i",$this->start_stamp);
			// end first term
			$year_end_date = $year_start_date;
			$month_end_date = $month_start_date;
			$day_end_date = $day_start_date;
			$hour_end_date = date("G",$this->end_stamp);
			$minute_end_date = date("i",$this->end_stamp);
			// if it starts at i.e. 23 hour and ends at 02 then we had
			// to increment the end day,maybe the month or even the year!!
			if ($hour_end_date < $hour_start_date)
			{
				$next_day = mktime($hour_start_date, $minute_start_date, 0, $month_start_date, $day_start_date, $year_start_date) + (60*60*24);
				// get the real values
				$day_end_date = date("d",$next_day);
				$year_end_date = date("Y",$next_day);
				$month_end_date = date("n",$next_day);
			}
			//first and last
			$first_termin = mktime($hour_start_date, $minute_start_date, 0, $month_start_date, $day_start_date, $year_start_date);
			// set
			$next_termin_start = $first_termin;
			$next_termin_end = mktime($hour_end_date, $minute_end_date, 0, $month_end_date, $day_end_date, $year_end_date);
			// intervall
			$weeks_interval = $this->interval;
			// day of the week

			// look for the first day of the week it should happens...
			while( date("w",$next_termin_start) !=  $this->day_of_the_week )
			{
				$next_termin_start += (60*60*24);
				$next_termin_end += (60*60*24);
				#echo "<p>" . date("d",$next_termin_start) ."/".date("n",$next_termin_start)."/".date("Y",$next_termin_start)." ".date("G",$next_termin_start).":".date("i",$next_termin_start);
				#echo "<p>" . date("d",$next_termin_end) ."/".date("n",$next_termin_end)."/".date("Y",$next_termin_end)." ".date("G",$next_termin_end).":".date("i",$next_termin_end);
				//exit;
			}

			// once we found the real first term and fix possible problems
			// we'll create for every term's interval his slots
			$anzahl_termine = 0;
			while ( $next_termin_start < $this->end_stamp)
			{
				// new class
				$next_termin = new Term();
				// insert it
				if (!($next_termin->insert($this->id,$next_termin_start, $next_termin_end)))
				{
					return false;
				}
				#echo "neuer termin mit id".$next_termin->id."<br>";
				// and create the slots
				if (!($next_termin->createSlots($this->duration)))
				{
					return false;
				}
				//es wurde ein termin angelegt...
				$anzahl_termine++;

				// english umwandelt
				$english_start = date("Y-m-d G:i:s",$next_termin_start);
				$english_end = date("Y-m-d G:i:s",$next_termin_end);
				// set the new termin
				//$next_termin_start = $next_termin_start + ($days_interval*(60*60*24));
				$next_termin_start = strtotime("$english_start + $weeks_interval weeks");
				$next_termin_end = strtotime("$english_end + $weeks_interval weeks");
			}
			return $anzahl_termine;
		}
	}
}

?>